<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\Fm00010000ParametrizacaoGeralService;
use FM\Traits\TResponse;

class Fm00010000ParametrizacaoGeralController extends FMCrud{
    use TResponse;
    
    protected $ParametrizacaoGeralService;
   
    public function __construct($crudService, $environment, Fm00010000ParametrizacaoGeralService $ParametrizacaoGeralService) {
        parent::__construct($crudService, $environment);
        $this->ParametrizacaoGeralService = $ParametrizacaoGeralService;
    }

    public function postMascara(Request $request, Response $response){
        try {
            $data = $this->ParametrizacaoGeralService->postMascara($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getMascara(Request $request, Response $response){
        try {
            $data = $this->ParametrizacaoGeralService->getMascara();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarRelacionamento(Request $request, Response $response){
        try {
            $data = $this->ParametrizacaoGeralService->salvarRelacionamento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getRelacionamentoServicoTipoMedida(Request $request, Response $response) {
        try {
            $data = $this->ParametrizacaoGeralService->getRelacionamentoServicoTipoMedida();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getItensRelacionamentoServicoTipoMedida(Request $request, Response $response) {
        try {
            $data = $this->ParametrizacaoGeralService->getItensRelacionamentoServicoTipoMedida($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inativarServicos(Request $request, Response $response) {
        try {
            $data = $this->ParametrizacaoGeralService->inativarServicos($request->getParameters());
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    
}

?>