<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\Fm00031000TarefasVistoriasContratoService;
use FM\Traits\TResponse;

class Fm00031000TarefasVistoriasContratoController extends FMCrud {

    use TResponse;
    protected $TarefasVistoriasContratoService;

    public function __construct($crudService, $environment, Fm00031000TarefasVistoriasContratoService $TarefasVistoriasContratoService) {
            parent::__construct($crudService, $environment);
            $this->TarefasVistoriasContratoService = $TarefasVistoriasContratoService;
    }

    public function getContratosTarefas(Request $request, Response $response) {
        try {
                $data = $this->TarefasVistoriasContratoService->getContratosTarefas();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getItensTarefasContratos(Request $request, Response $response) {
        try {
                $data = $this->TarefasVistoriasContratoService->getItensTarefasContratos($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getContratosVistoria(Request $request, Response $response) {
        try {
                $data = $this->TarefasVistoriasContratoService->getContratosVistoria();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getItensVistoriaContrato(Request $request, Response $response) {
        try {
                $data = $this->TarefasVistoriasContratoService->getItensVistoriaContrato($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }
    
}
