IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'VERIFICA_CONS_OL' AND
            TYPE = 'P'                        AND
            U.UID = O.UID                     AND
            U.NAME = USER)

   DROP PROCEDURE VERIFICA_CONS_OL;
GO

CREATE PROCEDURE VERIFICA_CONS_OL
(
    @P_CDFILIOPELOG  VARCHAR(4),
    @P_DTINICIAL     DATETIME,
    @P_DTFINAL       DATETIME,
    @P_CDPRODINI     VARCHAR(20),
    @P_CDPRODFIN     VARCHAR(20),
    @P_ROWSAFFECT    VARCHAR(1) OUTPUT
)
AS
   DECLARE @V_CDPRODINI      VARCHAR(20);
   DECLARE @V_CDPRODFIN      VARCHAR(20);
   DECLARE @V_CDFILSOLI      VARCHAR(4);
   DECLARE @V_PARAMPRODSUP   VARCHAR(10);
   DECLARE @V_N_PARAMPRODSUP VARCHAR(4);
   DECLARE @V_IDUTLMARPREFOL VARCHAR(1);
   DECLARE @V_IDUTPRODPREF   VARCHAR(1);
   DECLARE @V_CDGRUPPROD     VARCHAR(10);
   DECLARE @V_CDSUBGRARVOR   VARCHAR(10);
   DECLARE @V_CDPRODARVOL    VARCHAR(10);
   DECLARE @V_CDPRODFILI     VARCHAR(10);
   DECLARE @V_CDPRODPERI     VARCHAR(10);

   DECLARE @V_NRSEQUCONSOL   VARCHAR(10);
   DECLARE @V_NRSOLICMP      VARCHAR(10);
   DECLARE @V_CDFILSOLI1     VARCHAR(4);
   DECLARE @V_CDFILLAN       VARCHAR(4);
   DECLARE @V_CDPRODUTO      VARCHAR(10);
   DECLARE @V_CDARVPROD      VARCHAR(20);
   DECLARE @V_DTPROGENTR     DATETIME;
   DECLARE @V_IDSOLIAPROV    VARCHAR(1);
   DECLARE @V_IDITMCONS      VARCHAR(10);
   DECLARE @V_CDFILIOPELOG   VARCHAR(10);
   DECLARE @V_CDFILCENTCMP   VARCHAR(10);

BEGIN
   SET @V_CDFILSOLI  = 'X';
   SET @P_ROWSAFFECT = 'S';
   SET @V_CDPRODINI  = @P_CDPRODINI;
   SET @V_CDPRODFIN  = (SUBSTRING(@P_CDPRODFIN+(REPLICATE('Z', 20)), 1, 20));
   SELECT @V_NRSEQUCONSOL =
          SUBSTRING(REPLICATE('0', 10)+CONVERT(VARCHAR, CONVERT(NUMERIC, ISNULL(MAX(NRSEQUCONSOL), '0'))+1),
          LEN(CONVERT(VARCHAR, CONVERT(NUMERIC, ISNULL(MAX(NRSEQUCONSOL), '0'))+1))+1, 10)
     FROM CONSSOLOL
   DECLARE C_ITEMSOLI
    CURSOR FOR SELECT
                  ITEMSOLI.NRSOLICMP,
                  ITEMSOLI.CDFILSOLI,
                  ITEMSOLI.CDFILLAN,
                  PRODESTO.CDPRODUTO,
                  PRODESTO.CDARVPROD,
                  ITEMSOLI.DTPROGENTR,
                  ISNULL(ITEMSOLI.IDSOLIAPROV, 'S') IDSOLIAPROV,
                  ISNULL(ITEMSOLI.IDITMCONS, 'N') IDITMCONS,
                  ITEMSOLI.CDFILIOPELOG,
                  ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) CDFILCENTCMP
               FROM ITEMSOLI, PRODUTO, PRODUTO PRODESTO, FILIAL
               WHERE PRODUTO.CDPRODUTO      = ITEMSOLI.CDPRODUTO
                 AND PRODUTO.CDPRODESTO     = PRODESTO.CDPRODUTO
                 AND ITEMSOLI.CDFILSOLI     = FILIAL.CDFILIAL
                 AND ITEMSOLI.DTPROGENTR BETWEEN @P_DTINICIAL AND @P_DTFINAL
                 AND PRODESTO.CDARVPROD  BETWEEN @V_CDPRODINI AND @V_CDPRODFIN
                 AND ITEMSOLI.CDFILSOLI <> @P_CDFILIOPELOG
                 AND ((ITEMSOLI.CDFILIOPELOG IS NULL) OR
                     (ITEMSOLI.CDFILIOPELOG = @P_CDFILIOPELOG))
                 AND NOT EXISTS(SELECT 1
                                  FROM ITEMCONSSOLOL, PRODUTO
                                 WHERE ITEMCONSSOLOL.NRSEQUCONSOL  = ITEMSOLI.NRSEQUCONSOL
                                   AND ITEMCONSSOLOL.CDFILSOLI     = ITEMSOLI.CDFILSOLI
                                   AND ITEMCONSSOLOL.CDFILLAN      = ITEMSOLI.CDFILLAN
                                   AND ITEMCONSSOLOL.CDPRODUTO     = PRODUTO.CDPRODUTO
                                   AND PRODUTO.CDPRODESTO          = ITEMSOLI.CDPRODUTO
                                   AND ITEMCONSSOLOL.DTENTRCONSOL  = ITEMSOLI.DTPROGENTR)
               ORDER BY
                  ITEMSOLI.CDFILSOLI,
                  PRODESTO.CDPRODUTO,
                  ITEMSOLI.DTPROGENTR;
   OPEN C_ITEMSOLI;
      FETCH NEXT FROM C_ITEMSOLI INTO @V_NRSOLICMP,
                                      @V_CDFILSOLI1,
                                      @V_CDFILLAN,
                                      @V_CDPRODUTO,
                                      @V_CDARVPROD,
                                      @V_DTPROGENTR,
                                      @V_IDSOLIAPROV,
                                      @V_IDITMCONS,
                                      @V_CDFILIOPELOG,
                                      @V_CDFILCENTCMP;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_CDFILSOLI <> @V_CDFILSOLI1 BEGIN
         SET @V_CDFILSOLI       = @V_CDFILSOLI1;
         SET @V_IDUTLMARPREFOL  = NULL;
         SET @V_IDUTPRODPREF    = NULL;
         SET @V_CDGRUPPROD      = NULL;
         SET @V_CDSUBGRARVOR    = NULL;
         SELECT @V_IDUTLMARPREFOL = ISNULL(MAX(IDUTLMARPREFOL), 'N'),
                @V_CDGRUPPROD     = MAX(PARASUPRI.CDGRUPPROD),
                @V_CDSUBGRARVOR   = MAX(PARASUPRI.CDSUBGRARVOR)
           FROM PARASUPRI
          WHERE PARASUPRI.CDFILIAL  = @V_CDFILCENTCMP
            AND PARASUPRI.CDFILIAL  = @V_CDFILSOLI;
         SELECT @V_IDUTPRODPREF = ISNULL(MAX(IDUTPRODPREF), 'N')
           FROM PARCMPSUP
          WHERE CDFILIAL        = @V_CDFILSOLI;
      END;
      /*Item de solicitao no aprovada.*/
      IF @V_IDSOLIAPROV = 'N' BEGIN
         INSERT
           INTO VERIFCONSSOLOL
                (NRSEQUCONSOL, CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                DTPROGENTR, DTINICIAL, DTFINAL, CDPRODINI, CDPRODFIN, IDVERIFCONSOL, CDFILIOPELOG)
         VALUES (@V_NRSEQUCONSOL, @V_CDFILSOLI, @V_CDFILLAN, @V_NRSOLICMP, @V_CDPRODUTO,
                 @V_DTPROGENTR, @P_DTINICIAL, @P_DTFINAL, @P_CDPRODINI, @P_CDPRODFIN, '1', @P_CDFILIOPELOG);
         SET @P_ROWSAFFECT = 'N';
      END;
      /*Item de solicitao j consolidado.*/
      IF @V_IDITMCONS = 'S' BEGIN
         INSERT
           INTO VERIFCONSSOLOL
                (NRSEQUCONSOL, CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                DTPROGENTR, DTINICIAL, DTFINAL, CDPRODINI, CDPRODFIN, IDVERIFCONSOL, CDFILIOPELOG)
         VALUES (@V_NRSEQUCONSOL, @V_CDFILSOLI, @V_CDFILLAN, @V_NRSOLICMP, @V_CDPRODUTO,
                 @V_DTPROGENTR, @P_DTINICIAL, @P_DTFINAL, @P_CDPRODINI, @P_CDPRODFIN, '2', @P_CDFILIOPELOG);
         SET @P_ROWSAFFECT = 'N';
      END;
      IF (LEN(@V_CDFILIOPELOG) > 0) BEGIN
         /*Item de solicitao no parametrizado para a filial OL.*/
         SELECT @V_PARAMPRODSUP = MAX(PRODUTO.CDPRODUTO)
           FROM PARAMPRODSUP, PRODUTO
          WHERE PARAMPRODSUP.CDFILIOPELOG = @V_CDFILIOPELOG
            AND PARAMPRODSUP.CDFILIAL     = @V_CDFILSOLI1
            AND PRODUTO.CDPRODESTO        = @V_CDPRODUTO
            AND PARAMPRODSUP.CDPRODUTO    = PRODUTO.CDPRODUTO
            AND PARAMPRODSUP.NRCOLEPRECO  IS NULL
            AND PARAMPRODSUP.CDFILIOPELOG IS NOT NULL
            AND ISNULL(PARAMPRODSUP.CDFILISUBGR, 'X') = 'P';
         IF (@V_PARAMPRODSUP IS NULL) BEGIN
            INSERT
           INTO VERIFCONSSOLOL
                (NRSEQUCONSOL, CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                DTPROGENTR, DTINICIAL, DTFINAL, CDPRODINI, CDPRODFIN, IDVERIFCONSOL, CDFILIOPELOG)
         VALUES (@V_NRSEQUCONSOL, @V_CDFILSOLI, @V_CDFILLAN, @V_NRSOLICMP, @V_CDPRODUTO,
                 @V_DTPROGENTR, @P_DTINICIAL, @P_DTFINAL, @P_CDPRODINI, @P_CDPRODFIN, '3', @P_CDFILIOPELOG);
         SET @P_ROWSAFFECT = 'N';
         END;
         /*Item de solicitao inativo para a filial OL.*/
         SELECT @V_CDPRODFILI = MAX(PRODFILI.CDPRODUTO)
           FROM PRODFILI
          WHERE PRODFILI.CDPRODUTO = @V_CDPRODUTO
            AND PRODFILI.CDFILIAL  = @V_CDFILIOPELOG
            AND ISNULL(PRODFILI.IDPRODATIV, 'X') = 'A';
         IF (@V_CDPRODFILI IS NULL) BEGIN
            INSERT
           INTO VERIFCONSSOLOL
                (NRSEQUCONSOL, CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                DTPROGENTR, DTINICIAL, DTFINAL, CDPRODINI, CDPRODFIN, IDVERIFCONSOL, CDFILIOPELOG)
         VALUES (@V_NRSEQUCONSOL, @V_CDFILSOLI1, @V_CDFILLAN, @V_NRSOLICMP, @V_CDPRODUTO,
                 @V_DTPROGENTR, @P_DTINICIAL, @P_DTFINAL, @P_CDPRODINI, @P_CDPRODFIN, '4', @P_CDFILIOPELOG);
         SET @P_ROWSAFFECT = 'N';
         END;
      ELSE
         /*Item de solicitao definido para entrega direta.*/
         SELECT @V_N_PARAMPRODSUP = MAX(PARAMGERAL.CDFILIAL)
           FROM PARAMGERAL
          WHERE EXISTS (SELECT 1
                          FROM PARAMPRODSUP
                         WHERE PARAMPRODSUP.CDFILIAL     = @V_CDFILSOLI1
                           AND PARAMPRODSUP.CDFILIOPELOG = @V_CDFILIOPELOG
                           AND PARAMPRODSUP.CDGRUPPROD   = @V_CDGRUPPROD
                           AND PARAMPRODSUP.CDSUBGRPROD  = @V_CDSUBGRARVOR
                           AND PARAMPRODSUP.NRCOLEPRECO  IS NULL
                           AND PARAMPRODSUP.CDFILIOPELOG IS NOT NULL
                           AND ISNULL(PARAMPRODSUP.CDFILISUBGR, 'X') = 'P');
         IF (@V_N_PARAMPRODSUP IS NULL) BEGIN
            INSERT
           INTO VERIFCONSSOLOL
                (NRSEQUCONSOL, CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                DTPROGENTR, DTINICIAL, DTFINAL, CDPRODINI, CDPRODFIN, IDVERIFCONSOL, CDFILIOPELOG)
         VALUES (@V_NRSEQUCONSOL, @V_CDFILSOLI1, @V_CDFILLAN, @V_NRSOLICMP, @V_CDPRODUTO,
                 @V_DTPROGENTR, @P_DTINICIAL, @P_DTFINAL, @P_CDPRODINI, @P_CDPRODFIN, '5', @P_CDFILIOPELOG);
         SET @P_ROWSAFFECT = 'N';
         END;
      END;
      /*Item de solicitaco sem relacionamento com o produto do OL.*/
      SELECT @V_CDPRODARVOL = MAX(RELACPRODOL.CDPRODARVOL)
        FROM RELACPRODOL
       WHERE RELACPRODOL.CDPRARVORIG = @V_CDPRODUTO;
      IF (@V_CDPRODARVOL IS NULL) BEGIN
         INSERT
           INTO VERIFCONSSOLOL
                (NRSEQUCONSOL, CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                DTPROGENTR, DTINICIAL, DTFINAL, CDPRODINI, CDPRODFIN, IDVERIFCONSOL, CDFILIOPELOG)
         VALUES (@V_NRSEQUCONSOL, @V_CDFILSOLI, @V_CDFILLAN, @V_NRSOLICMP, @V_CDPRODUTO,
                 @V_DTPROGENTR, @P_DTINICIAL, @P_DTFINAL, @P_CDPRODINI, @P_CDPRODFIN, '6', @P_CDFILIOPELOG);
         SET @P_ROWSAFFECT = 'N';
      END;
      /*Item de solicitao sem periodicidade para a filial OL.*/
      SELECT @V_CDPRODPERI = MAX(B.CDARVPROD)
        FROM PERFILPROD A, PRODUTO B
       WHERE A.CDPRODUTO = B.CDPRODUTO
         AND  A.CDFILIAL  = @P_CDFILIOPELOG
         AND  CHARINDEX(B.CDARVPROD, @V_CDARVPROD) = 1;
      IF (@V_CDPRODPERI IS NULL) BEGIN
         INSERT
           INTO VERIFCONSSOLOL
                (NRSEQUCONSOL, CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                DTPROGENTR, DTINICIAL, DTFINAL, CDPRODINI, CDPRODFIN, IDVERIFCONSOL, CDFILIOPELOG)
         VALUES (@V_NRSEQUCONSOL, @V_CDFILSOLI1, @V_CDFILLAN, @V_NRSOLICMP, @V_CDPRODUTO,
                 @V_DTPROGENTR, @P_DTINICIAL, @P_DTFINAL, @P_CDPRODINI, @P_CDPRODFIN, '7', @P_CDFILIOPELOG);
         SET @P_ROWSAFFECT = 'N';
      END;

      FETCH NEXT FROM C_ITEMSOLI INTO @V_NRSOLICMP,
                                      @V_CDFILSOLI1,
                                      @V_CDFILLAN,
                                      @V_CDPRODUTO,
                                      @V_CDARVPROD,
                                      @V_DTPROGENTR,
                                      @V_IDSOLIAPROV,
                                      @V_IDITMCONS,
                                      @V_CDFILIOPELOG,
                                      @V_CDFILCENTCMP;
   END;
   CLOSE C_ITEMSOLI;
   DEALLOCATE C_ITEMSOLI;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'VERIFICA_CONS_OL','5.50.xxx';
GO

